"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getLines(data, width, height) {
    var channels = data.length / (width * height);
    var lines = [];
    var count = 0;
    var colSum = 0;
    var colAvg = 0;
    var colAvgLast = 0;
    for (var col = 0; col < width; col += 1) {
        colSum = 0;
        for (var row = 0; row < height; row += 1) {
            colSum += data[(row * width + col) * channels];
        }
        // atleast 75% of the pixels are same in column
        colAvg = colSum / height >= 127 ? 255 : 0;
        // skip white padding in the start
        if (count === 0 && colAvg === 255)
            continue;
        // count line width
        if (colAvg === colAvgLast) {
            count += 1;
        }
        else {
            lines.push(count);
            count = 1;
            colAvgLast = colAvg;
        }
        // skip padding in the last
        if (col === width - 1 && colAvg === 0) {
            lines.push(count);
        }
    }
    return lines;
}
exports.getLines = getLines;
//# sourceMappingURL=getLines.js.map