"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function applyMedianFilter(data, width, height) {
    var channels = data.length / (width * height);
    var window = [
        [-1, -1],
        [-1, 0],
        [-1, 1],
        [0, -1],
        [0, 0],
        [0, 1],
        [1, -1],
        [1, 0],
        [1, 1]
    ];
    for (var col = 1; col < width - 1; col += 1) {
        for (var row = 1; row < height - 1; row += 1) {
            var i = (row * width + col) * channels;
            var arr = [];
            for (var z = 0; z < window.length; z += 1) {
                var i_1 = ((row + window[z][0]) * width + (col + window[z][1])) * channels;
                var v_1 = (data[i_1] + data[i_1 + 1] + data[i_1 + 2]) / 3;
                arr.push(v_1);
            }
            var v = arr.sort(function (a, b) { return a - b; })[4] >= 127 ? 255 : 0;
            data[i] = v;
            data[i + 1] = v;
            data[i + 2] = v;
        }
    }
    return data;
}
exports.applyMedianFilter = applyMedianFilter;
//# sourceMappingURL=medianFilter.js.map