export declare enum BARCODE_DECODERS {
    'code-128' = "code-128",
    'code-2of5' = "code-2of5",
    'code-39' = "code-39",
    'code-93' = "code-93",
    'ean-13' = "ean-13",
    'ean-8' = "ean-8",
    'codabar' = "codabar"
}
export interface ImageDataLike {
    data: Uint8ClampedArray;
    width: number;
    height: number;
}
declare type JavascriptBarcodeReader = {
    image: string | HTMLImageElement | HTMLCanvasElement | ImageDataLike;
    barcode: string | BARCODE_DECODERS;
    barcodeType?: string;
    options?: {
        useAdaptiveThreshold?: boolean;
        singlePass?: boolean;
    };
};
export declare function javascriptBarcodeReader({ image, barcode, barcodeType, options }: JavascriptBarcodeReader): Promise<string>;
export {};
